package pl.primesoft.aztecreaderdemo;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;

import pl.primesoft.aztecreaderdemo.Scanning.ScanningActivity;

public class MainActivity extends Activity {

    private boolean paused = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }

    @Override
    protected void onResume() {
        super.onResume();
        paused = false;
        findViewById(R.id.splashImage).postDelayed(new Runnable() {
            @Override
            public void run() {
                if (!paused) {
                    navigateToScanningWithCameraManagerActivity();
                    overridePendingTransition(android.R.anim.fade_in, android.R.anim.fade_out);
                    finish();
                }
            }
        }, 700);
    }

    @Override
    protected void onPause() {
        paused = true;
        super.onPause();
    }

    private void navigateToScanningWithCameraManagerActivity() {
        Intent intent = new Intent(this, ScanningActivity.class);
        startActivity(intent);
    }
}
