package pl.primesoft.aztecreaderdemo.Scanning.CameraManager.Utils;

import android.content.Context;
import android.content.pm.PackageManager;
import android.hardware.Camera;

import java.util.List;

/**
 * Created by wygralak on 2016-03-15.
 */
public class FlashUtils {

    public static boolean isFlashAvailable(Camera camera, Context context) {
        if (!context.getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA_FLASH)) {
            return false;
        }
        Camera.Parameters parameters = camera.getParameters();
        if (parameters.getFlashMode() == null) {
            return false;
        }
        List<String> supportedFlashModes = parameters.getSupportedFlashModes();
        if (supportedFlashModes == null || supportedFlashModes.isEmpty() ||
                !supportedFlashModes.contains(Camera.Parameters.FLASH_MODE_TORCH)) {
            return false;
        }
        return true;
    }


    public static String toggleFlash(Camera camera)  {
        Camera.Parameters parameters = camera.getParameters();
        String flashMode = camera.getParameters().getFlashMode().equals(Camera.Parameters.FLASH_MODE_OFF) ?
                Camera.Parameters.FLASH_MODE_TORCH :
                Camera.Parameters.FLASH_MODE_OFF;
        parameters.setFlashMode(flashMode);
        camera.setParameters(parameters);
        return flashMode;
    }
}
