package pl.primesoft.aztecreaderdemo.Scanning.CameraManager.Utils;

import android.hardware.Camera;
import android.view.View;

import java.util.List;

/**
 * Created by wygralak on 2016-03-15.
 */
public class ZoomUtils {
    private int zoomlevel = 0;
    private int zoom1 = -1;
    private int zoom2 = -1;

    public static boolean isZoomAvailable(Camera camera) {
        boolean res = camera.getParameters().isZoomSupported();
        if (!res) {
            return false;
        }
        List<Integer> zoomRatios = camera.getParameters().getZoomRatios();
        return (zoomRatios != null && zoomRatios.size() > 0);
    }

    public View.OnClickListener setupZoom(final Camera camera) {
        initZoomValues(camera);
        if (zoom1 != -1) {
            return new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    zoomlevel++;
                    if (zoomlevel > 2) {
                        zoomlevel = 0;
                    }
                    switch (zoomlevel) {
                        case 0: {
                            zoomTo(camera, 0);
                            break;
                        }
                        case 1: {
                            zoomTo(camera, zoom1);
                            break;
                        }
                        case 2: {
                            zoomTo(camera, zoom2);
                            break;
                        }
                    }
                }
            };
        }
        return null;
    }

    private void zoomTo(Camera camera, int zoom) {
        Camera.Parameters parameters = camera.getParameters();
        parameters.setZoom(zoom);
        camera.setParameters(parameters);
    }

    private void initZoomValues(Camera camera) {
        List<Integer> zoomRatios = camera.getParameters().getZoomRatios();
        if (zoomRatios != null && zoomRatios.size() > 0) {
            int maxZoom = zoomRatios.get(zoomRatios.size() - 1);
            zoom2 = zoomRatios.size() - 1;
            int tempzoom = 100 + ((maxZoom - 100) / 2);
            int min = Math.abs(tempzoom - zoomRatios.get(0));
            zoom1 = 0;
            for (int i = 1; i < zoomRatios.size(); i++) {
                int diff = Math.abs(tempzoom - zoomRatios.get(i));
                if (diff < min) {
                    min = diff;
                    zoom1 = i;
                }
            }
        }
    }
}
