package pl.primesoft.aztecreaderdemo.Views;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Paint;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;

import pl.primesoft.aztecreaderdemo.BuildConfig;
import pl.primesoft.aztecreaderdemo.R;

/**
 * Created by wygralak on 2016-04-20.
 */
public abstract class AboutDialog {
    private AlertDialog dialog;

    public AboutDialog(Context context) {
        dialog = new AlertDialog.Builder(context)
                .setView(getCustomView(context))
                .create();
    }

    public void show() {
        if (dialog != null) {
            dialog.show();
        }
    }

    public void dismiss() {
        if (dialog != null) {
            dialog.dismiss();
        }
    }

    private View getCustomView(Context context) {
        View layout = LayoutInflater.from(context).inflate(R.layout.about_view, null);
        TextView versionTv = (TextView) layout.findViewById(R.id.versionTv);
        versionTv.setText(context.getString(R.string.version_text, BuildConfig.VERSION_NAME));
        TextView aztecTv = (TextView) layout.findViewById(R.id.urlTV);
        aztecTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String url = v.getResources().getString(R.string.full_url);
                navigateToWebsite(url);
            }
        });
        TextView privacyPolicy = (TextView) layout.findViewById(R.id.privacy_policy);
        privacyPolicy.setPaintFlags(privacyPolicy.getPaintFlags() | Paint.UNDERLINE_TEXT_FLAG);
        privacyPolicy.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String url = v.getResources().getString(R.string.privacy_policy_url);
                navigateToWebsite(url);
            }
        });
        return layout;
    }

    public void setOnDismissListener(DialogInterface.OnDismissListener listener) {
        dialog.setOnDismissListener(listener);
    }

    public abstract void navigateToWebsite(String url);
}
